//
// INTEL CONFIDENTIAL
// Copyright (c) 2008 Intel Corp.  Recipient is granted a non-sublicensable 
// copyright license under Intel copyrights to copy and distribute this code 
// internally only. This code is provided "AS IS" with no support and with no 
// warranties of any kind, including warranties of MERCHANTABILITY,
// FITNESS FOR ANY PARTICULAR PURPOSE or INTELLECTUAL PROPERTY INFRINGEMENT. 
// By making any use of this code, Recipient agrees that no other licenses 
// to any Intel patents, trade secrets, copyrights or other intellectual 
// property rights are granted herein, and no other licenses shall arise by 
// estoppel, implication or by operation of law. Recipient accepts all risks 
// of use.
//

// possibly use include paths to hide existing modules?

#ifndef __AUDIO_PROCESSOR_CONNECTED_APPLICATION__
#define __AUDIO_PROCESSOR_CONNECTED_APPLICATION__

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#include "asim/provides/virtual_platform.h"

#include "asim/rrr/client_stub_AUDIOPROCESSORRRR.h"

typedef enum {
  EndOfFile = 0,
  Data = 1
} AudioProcessorControl; 


typedef class CONNECTED_APPLICATION_CLASS* CONNECTED_APPLICATION;
class CONNECTED_APPLICATION_CLASS : public PLATFORMS_MODULE_CLASS
{
  private:
    AUDIOPROCESSORRRR_CLIENT_STUB clientStub;
    static sem_t throttle;
    static pthread_mutex_t lock;
    static pthread_cond_t  cond;    

  public:
    CONNECTED_APPLICATION_CLASS(VIRTUAL_PLATFORM vp);
    ~CONNECTED_APPLICATION_CLASS();
    static void EndSimulation();
    static void UpdateSemaphore();

    // init
    void Init();

    // main
    void Main();
};

#endif
